package expandDG;

import util.listreader.*;
import java.io.*;
import util.arrapp.Arrapp;

public class ListDriven{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------
  
  static String[] dfds = null;
  static String[] arities = null;
  static int[][] functions = null;
  
  static String list = "";
  
  static boolean verbose = false;

// --------------------------------------------------------
// Main
// --------------------------------------------------------

  public static void main(String[] args) {
    init();
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------
  
  static void init() {
    ListReader LR = new ListReader(list);
    LR.initialize();
    String[] lines = LR.readAll();
    String[] parsed;
    int[] func;
    dfds = null;
    arities = null;
    functions = null;
    for (int i = 0; i < lines.length; i++) {
      parsed = parse(lines[i]);
      dfds = Arrapp.append(dfds,parsed[0]);
      arities = Arrapp.append(arities,parsed[1]);
      func = new int[parsed.length-2];
      for (int j = 0; j < func.length; j++) {
        func[j] = Integer.parseInt(parsed[j+2]);
      }
      functions = Arrapp.append(functions,func);
    }
    //diag
    if (verbose) {
      for (int i = 0; i < lines.length; i++) {
        String M = dfds[i] + "-" + arities[i] + "-";
        for (int j = 0; j < functions[i].length; j++) {
          M += Integer.toString(functions[i][j]) + "-";
        }
        System.out.println(M);
      }
    }
    //
  }
  
  static boolean record() {
    boolean success = true;
    try {
      File outfile = new File(list);
      FileOutputStream out = new FileOutputStream(outfile);
      String L;
      for (int i = 0; i < dfds.length; i++) {
        L = dfds[i] + ":" + arities[i];
        for (int j = 0; j < functions[i].length; j++) {
          L += ":" + Integer.toString(functions[i][j]);
        }
        L += "\n";
        out.write(L.getBytes());
      }
    } catch (IOException e) {
      success = false;
    }
    return success;
  }
  
  static String[] parse(String s) {
    String[] a = null;
    int[] b = new int[1];
    b[0] = -1;
    for (int w = 0; w < s.length(); w++) {
      if (s.substring(w,w+1).equals(":")) {
        b = Arrapp.append(b,w);
      }
    }
    b = Arrapp.append(b,s.length());
    for (int j = 0; j < b.length - 1; j++) {
      a = Arrapp.append(a,s.substring(b[j]+1,b[j+1]));
    }
    return a;
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 